/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2023 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "crc.h"
#include "dma.h"
#include "i2c.h"
#include "rtc.h"
#include "spi.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "ssd1306.h"
#include "LoRa.h"
#include "lora_crc.h"
#include "onewire.h"
#include "ds18b20.h"
#include "rtc_conf.h"
#include "gps_parser.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
typedef union
{
	float float_variable;
	uint8_t bytes[4];
} float2bytes_t;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define LORA_MESSAGE_TIME 2000
#define LORA_MESSAGE_LENGTH 8
#define TEMPERATURE_OFFSET 127
#define NUMBER_OF_LCD_PAGES 2

#define SET_RTC
#define UART_DEBUG
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

// LoRa
LoRa myLoRa;
uint8_t read_data[LORA_MESSAGE_LENGTH];
uint8_t send_data[LORA_MESSAGE_LENGTH];
int RSSI;
uint16_t lora_status;
volatile uint8_t lora_rx_flag = 0;
uint32_t SoftTimerLoraSend;
uint32_t time_tick;
uint32_t time_tock;
uint32_t time_interval;
uint8_t msg_id = 0;

// LCD
char lcd_line[64];
volatile uint8_t lcd_page = 0;

// Temperature sensing
float plant_temperature;

// Timestamp
extern RTC_TimeTypeDef timeNow;
extern RTC_DateTypeDef dateNow;

// Debug
uint8_t UartMessage[64];
uint8_t UartMessageLength;

// GPS
float2bytes_t gps_longitude;
float2bytes_t gps_latitude;
volatile uint8_t gps_data_received_flag = 0;
uint8_t gps_data_ok_flag = 0;
float latitude;
float longitude;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
	/* USER CODE BEGIN 1 */

	/* USER CODE END 1 */

	/* MCU Configuration--------------------------------------------------------*/

	/* Reset of all peripherals, Initializes the Flash interface and the Systick. */
	HAL_Init();

	/* USER CODE BEGIN Init */

	/* USER CODE END Init */

	/* Configure the system clock */
	SystemClock_Config();

	/* USER CODE BEGIN SysInit */

	/* USER CODE END SysInit */

	/* Initialize all configured peripherals */
	MX_GPIO_Init();
	MX_DMA_Init();
	MX_USART2_UART_Init();
	MX_I2C1_Init();
	MX_SPI1_Init();
	MX_TIM7_Init();
	MX_RTC_Init();
	MX_CRC_Init();
	MX_USART1_UART_Init();
	/* USER CODE BEGIN 2 */

#ifdef SET_RTC
	SetRtcCompilationTimeAndDate();
#endif

	DS18B20_Init(DS18B20_Resolution_12bits);

	ssd1306_Init();
	ssd1306_Fill(Black);
	ssd1306_SetCursor(20, 0);
	ssd1306_WriteString("ufnalski.edu.pl", Font_6x8, White);
	ssd1306_SetCursor(15, 10);
	ssd1306_WriteString("LoRa SX1278 demo", Font_6x8, White);
	ssd1306_UpdateScreen();

	// LoRa module settings ----------------------------------------------
	myLoRa = newLoRa();

	myLoRa.hSPIx = &hspi1;
	myLoRa.CS_port = LORA_NSS_GPIO_Port;
	myLoRa.CS_pin = LORA_NSS_Pin;
	myLoRa.reset_port = LORA_RST_GPIO_Port;
	myLoRa.reset_pin = LORA_RST_Pin;
	myLoRa.DIO0_port = LORA_DIO0_GPIO_Port;
	myLoRa.DIO0_pin = LORA_DIO0_Pin;

	myLoRa.frequency = 433;							  // default = 433 MHz
	myLoRa.spredingFactor = SF_8; // SF_8;							// default = SF_7
	myLoRa.bandWidth = BW_31_25KHz; // BW_31_25KHz;				  // default = BW_125KHz
	myLoRa.crcRate = CR_4_5;						// default = CR_4_5
	myLoRa.power = POWER_20db;				// default = 20db
	myLoRa.overCurrentProtection = 120; 					// default = 100 mA
	myLoRa.preamble = 10;		  					// default = 8;

	LoRa_reset(&myLoRa);
	lora_status = LoRa_init(&myLoRa);

	LoRa_startReceiving(&myLoRa);

	SoftTimerLoraSend = HAL_GetTick();

	StartReadingGps();

#ifdef UART_DEBUG
	UartMessageLength = sprintf((char*) UartMessage, "\033[2J\033[;H"); // Clear terminal and home cursor
	HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength, 1000);
#endif

	/* USER CODE END 2 */

	/* Infinite loop */
	/* USER CODE BEGIN WHILE */

	while (1)
	{
		// LoRa receive
		if (lora_rx_flag == 1)
		{
			LoRa_receive(&myLoRa, read_data, LORA_MESSAGE_LENGTH);
			lora_rx_flag = 0;
			if (lcd_page == 0)
			{
				sprintf(lcd_line, "Node addr.: %x       ", read_data[0]);
				ssd1306_SetCursor(2, 35);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				sprintf(lcd_line, "Temp.: %i deg. C     ",
						(int16_t) (read_data[1]) - TEMPERATURE_OFFSET);
				ssd1306_SetCursor(2, 45);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				sprintf(lcd_line, "CRC: %s            ",
						0 == lora_crc_byte(read_data, LORA_MESSAGE_LENGTH) ?
								"OK" : "ERROR");
				ssd1306_SetCursor(2, 55);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				ssd1306_UpdateScreen();
			}
			HAL_GPIO_TogglePin(LD3_GPIO_Port, LD3_Pin);
		}

		// GPS receive
		if (gps_data_received_flag == 1)
		{
			gps_data_received_flag = 0;
			gps_data_ok_flag = ParseGpsData(&latitude, &longitude);
		}

		// LoRa send
		if ((HAL_GetTick() - SoftTimerLoraSend) > LORA_MESSAGE_TIME)
		{
			SoftTimerLoraSend = HAL_GetTick();
			DS18B20_ReadAll();
			DS18B20_StartAll();
			HAL_RTC_GetTime(&hrtc, &timeNow, RTC_FORMAT_BIN);
			HAL_RTC_GetDate(&hrtc, &dateNow, RTC_FORMAT_BIN);

			if (msg_id == 0)
			{
				if (DS18B20_GetTemperature(0, &plant_temperature))
				{
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = (uint8_t) (plant_temperature
							+ TEMPERATURE_OFFSET);
					send_data[3] = timeNow.Hours;
					send_data[4] = timeNow.Minutes;
					send_data[5] = timeNow.Seconds;
					send_data[6] = 0;
					sprintf(lcd_line, "My temp.: %i deg. C  ",
							(int16_t) (send_data[2]) - TEMPERATURE_OFFSET);
					ssd1306_SetCursor(2, 25);
					ssd1306_WriteString(lcd_line, Font_6x8, White);
					ssd1306_UpdateScreen();
				}
				else
				{
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = timeNow.Hours;
					send_data[3] = timeNow.Minutes;
					send_data[4] = timeNow.Seconds;
					send_data[5] = 0;
					send_data[6] = 0;
				}
				send_data[LORA_MESSAGE_LENGTH - 1] = lora_crc_byte(send_data,
				LORA_MESSAGE_LENGTH - 1);
				lora_status = LoRa_transmit(&myLoRa, send_data,
				LORA_MESSAGE_LENGTH, 200);
			} // if (msg_id == 0)

			if (msg_id == 1)
			{
				if (gps_data_ok_flag == 1)
				{
					StartReadingGps();

					gps_latitude.float_variable = latitude;
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = gps_latitude.bytes[0];
					send_data[3] = gps_latitude.bytes[1];
					send_data[4] = gps_latitude.bytes[2];
					send_data[5] = gps_latitude.bytes[3];
					send_data[6] = 0;

					if (lcd_page == 1)
					{
						sprintf(lcd_line, "                             ");
						ssd1306_SetCursor(2, 35);
						ssd1306_WriteString(lcd_line, Font_6x8, White);
						sprintf(lcd_line, "My lat.:  %.6f       ",
								gps_latitude.float_variable);
						ssd1306_SetCursor(2, 45);
						ssd1306_WriteString(lcd_line, Font_6x8, White);
						ssd1306_UpdateScreen();
					}

				}
				else
				{
#ifdef UART_DEBUG
					UartMessageLength = sprintf((char*) UartMessage,
							"No Fix\n\r");
					HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
							1000);
#endif
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = 0xD;
					send_data[3] = 0xE;
					send_data[4] = 0xA;
					send_data[5] = 0xD;
					send_data[6] = 0;
				}

				send_data[LORA_MESSAGE_LENGTH - 1] = lora_crc_byte(send_data,
				LORA_MESSAGE_LENGTH - 1);
				lora_status = LoRa_transmit(&myLoRa, send_data,
				LORA_MESSAGE_LENGTH, 200);
			} // if (msg_id == 1)

			if (msg_id == 2)
			{
				if (gps_data_ok_flag == 1)
				{
					StartReadingGps();

					gps_longitude.float_variable = longitude;
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = gps_longitude.bytes[0];
					send_data[3] = gps_longitude.bytes[1];
					send_data[4] = gps_longitude.bytes[2];
					send_data[5] = gps_longitude.bytes[3];
					send_data[6] = 0;

					if (lcd_page == 1)
					{
						sprintf(lcd_line, "My long.: %.6f       ",
								gps_longitude.float_variable);
						ssd1306_SetCursor(2, 55);
						ssd1306_WriteString(lcd_line, Font_6x8, White);
						ssd1306_UpdateScreen();
					}
				}
				else
				{
#ifdef UART_DEBUG
					UartMessageLength = sprintf((char*) UartMessage,
							"No Fix\n\r");
					HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
							1000);
#endif
					send_data[0] = 0x1a; // MY ADDRESS
					send_data[1] = msg_id;
					send_data[2] = 0xD;
					send_data[3] = 0xE;
					send_data[4] = 0xA;
					send_data[5] = 0xD;
					send_data[6] = 0;
				}

				send_data[LORA_MESSAGE_LENGTH - 1] = lora_crc_byte(send_data,
				LORA_MESSAGE_LENGTH - 1);

				time_tick = HAL_GetTick();
				lora_status = LoRa_transmit(&myLoRa, send_data,
				LORA_MESSAGE_LENGTH, 200);
				time_tock = HAL_GetTick();
				time_interval = time_tock - time_tick;
			} // if (msg_id == 2)

			msg_id++;
			msg_id %= 3;

#ifdef UART_DEBUG
			UartMessageLength = sprintf((char*) UartMessage, "\033[2J\033[;H"); // Clear terminal and home cursor
			HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength, 1000);

			UartMessageLength = sprintf((char*) UartMessage,
					"Latitude:  %.6f\n\r", latitude);
			HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength, 1000);

			UartMessageLength = sprintf((char*) UartMessage,
					"Longitude: %.6f\n\r", longitude);
			HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength, 1000);
#endif
		}

		/* USER CODE END WHILE */

		/* USER CODE BEGIN 3 */
	}
	/* USER CODE END 3 */
}

/**
 * @brief System Clock Configuration
 * @retval None
 */
void SystemClock_Config(void)
{
	RCC_OscInitTypeDef RCC_OscInitStruct =
	{ 0 };
	RCC_ClkInitTypeDef RCC_ClkInitStruct =
	{ 0 };

	/** Configure the main internal regulator output voltage
	 */
	if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
	{
		Error_Handler();
	}

	/** Configure LSE Drive Capability
	 */
	HAL_PWR_EnableBkUpAccess();
	__HAL_RCC_LSEDRIVE_CONFIG(RCC_LSEDRIVE_LOW);

	/** Initializes the RCC Oscillators according to the specified parameters
	 * in the RCC_OscInitTypeDef structure.
	 */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSI
			| RCC_OSCILLATORTYPE_LSE | RCC_OSCILLATORTYPE_MSI;
	RCC_OscInitStruct.LSEState = RCC_LSE_ON;
	RCC_OscInitStruct.LSIState = RCC_LSI_ON;
	RCC_OscInitStruct.MSIState = RCC_MSI_ON;
	RCC_OscInitStruct.MSICalibrationValue = 0;
	RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_6;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_MSI;
	RCC_OscInitStruct.PLL.PLLM = 1;
	RCC_OscInitStruct.PLL.PLLN = 40;
	RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
	RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
	RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
	if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{
		Error_Handler();
	}

	/** Initializes the CPU, AHB and APB buses clocks
	 */
	RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_SYSCLK
			| RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2;
	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
	RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

	if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
	{
		Error_Handler();
	}

	/** Enable MSI Auto calibration
	 */
	HAL_RCCEx_EnableMSIPLLMode();
}

/* USER CODE BEGIN 4 */
void HAL_UARTEx_RxEventCallback(UART_HandleTypeDef *huart, uint16_t Size)
{
	if (huart->Instance == USART1)
	{
		gps_data_received_flag = 1;
	}
}

void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if (GPIO_Pin == myLoRa.DIO0_pin)
	{
		lora_rx_flag = 1;
	}

	if (GPIO_Pin == USER_BUTTON_Pin)
	{
		lcd_page++;
		lcd_page %= NUMBER_OF_LCD_PAGES;
	}
}
/* USER CODE END 4 */

/**
 * @brief  This function is executed in case of error occurrence.
 * @retval None
 */
void Error_Handler(void)
{
	/* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1)
	{
	}
	/* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
